          ;*************************************
          ;   SOFTWARE FOR ET-BOARD VER 3.5    *
          ;        PROGRAM TEST ADC0804        *
          ;           FREE RUN MODE            *
          ;   DIGITAL INPUT OF ET-ADIO BOARD   *
          ;*************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
IC_ADC:   EQU 8AH         ; port input of ADC0804
D_DSP:    EQU 01H         ; data control LED flag
P_DSP:    EQU 02H         ; port enable LED flag
FLAG:     EQU 06H         ; data to enable LED flag
BUF:      EQU 3FEFH       ; buffer display (BCD)
DSP:      EQU 3FE7H       ; buffer display (7 segment)
HBUF:     EQU 3FF2H       ; buffer (HEX) of HTOD,DTOH
DBUF:     EQU 3FF4H       ; buffer (DEC) of HTOD,DTOH


          ;******************
          ;*  MAIN PROGRAM  *
          ;******************

IN_ADC:   IN A,(IC_ADC)   ; read input ADC0804
          CALL DSP_FLAG   ; display LED flag
          CALL DSP_SEG    ; display 7 segment
          LD A,0FH        ; call "DELAY"
          LD B,05H        ; delay time
          RST 10H
          JR IN_ADC       ; loop for read ADC


          ;***************************
          ;*  SUB. DISPLAY LED FLAG  *
          ;***************************

DSP_FLAG: PUSH AF         ; store input
          LD A,FLAG
          OUT (P_DSP),A   ; set LED flag active
          POP AF          ; restore input
          OUT (D_DSP),A   ; display LED flag
          RET


          ;*********************************
          ;     SUB. DISPLAY  7 SEGMENT    *
          ;*********************************

DSP_SEG:  PUSH AF
          LD (BUF+2),A    ; store display buffer
          LD (HBUF+0),A   ; store input "H TO D"
          LD A,0
          LD (HBUF+1),A
          LD A,0AH        ; call "H TO D"
          RST 10H         ; HEX -> DEC
          LD  A,(DBUF+0)
          LD  (BUF+0),A   ; store input "UNPK"
          LD  A,(DBUF+1)
          LD  (BUF+1),A
          LD  A,07H       ; call "UNPK"
          RST 10H         ; BUF -> DSP
          LD A,(DSP+1)    ; shift digit to left
          LD (DSP+0),A
          LD A,(DSP+2)
          LD (DSP+1),A
          LD A,(DSP+3)
          LD (DSP+2),A
          LD A,00H
          LD (DSP+3),A
          LD A,04H        ; call "SCAN"
          LD B,01H        ; delay time
          RST 10H
          POP AF
          RET
          END
