           ;*************************************
           ;   SOFTWARE FOR ET-BOARD VER 3.5    *
           ;       PROGRAM TEST 74LS245         *
           ;   DIGITAL INPUT OF ET-ADIO BOARD   *
           ;*************************************

                       CPU "Z80.TBL"
                       HOF  "INT8"

           ORG 2000H
IP_SW:     EQU 8DH         ; port input of 74LS245
D_DSP:     EQU 01H         ; port control LED flag
P_DSP:     EQU 02H         ; port enable LED flag
FLAG:      EQU 06H         ; data to enable LED flag
DSP:       EQU 3FE7H       ; display buffer (7 segment)
BUF:       EQU 3FEFH       ; display buffer (BCD)
HBUF:      EQU 3FF2H       ; buffer (HEX) of HTOD,DTOH
DBUF:      EQU 3FF4H       ; buffer (DEC) of HTOD,DTOH


           ;*******************
           ;   MAIN PROGRAM   *
           ;*******************

IN_SW:     IN A,(IP_SW)    ; read input (from 74LS245)
           XOR 00FFH       ; complement logic input
           CALL DSP_FLAG   ; display input to LED flag
           CALL DSP_SEG    ; display input to 7 segment
           JR IN_SW        ; loop for read input continue


           ;*********************************
           ;     SUB.  DISPLAY LED FLAG     *
           ;*********************************

DSP_FLAG:  PUSH AF         ; store input
           LD A,FLAG
           OUT (P_DSP),A   ; set LED flag active
           POP AF          ; restore input
           OUT (D_DSP),A   ; out data to LED flag
           RET


           ;*********************************
           ;     SUB. DISPLAY  7 SEGMENT    *
           ;*********************************

DSP_SEG:   PUSH AF         ; store input
           LD (BUF+2),A    ; store input buffer
           LD (HBUF+0),A   ; store input "HTOD"
           LD A,00H
           LD (HBUF+1),A
           LD A,0AH        ; call "H TO D"
           RST 10H         ; HEX -> DEC
           LD  A,(DBUF+0)  ;store input "UNPK"
           LD  (BUF+0),A
           LD  A,(DBUF+1)
           LD  (BUF+1),A
           LD  A,07H       ; call "UNPK"
           RST 10H         ; BUF -> DSP
           LD A,(DSP+1)    ; shift digit to left
           LD (DSP+0),A
           LD A,(DSP+2)
           LD (DSP+1),A
           LD A,(DSP+3)
           LD (DSP+2),A
           LD A,00H
           LD (DSP+3),A
           LD A,04H        ; call "SCAN"
           LD B,01H        ; delay time
           RST 10H
           POP AF
           RET
           END
