          ;************************************
          ;*   SOFTWARE FOR ET-BOARD VER 4.0  *
          ;*       PROGRAM TEST ADC0804       *
          ;*          FREE RUN MODE           *
          ;*   ANALOG INPUT OF ET-ADIO BOARD  *
          ;************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
IC_ADC:   EQU 8AH           ; ADC port control
CBUF:     EQU 3FB3H         ; buffer calcalator


          ;********************
          ;*   MAIN PROGRAM   *
          ;********************

START:    CALL DSPLCD      ; display LCD
          IN A,(IC_ADC)    ; read ADC0804
          LD D,A
          LD E,32H
          LD A,29H         ; call "DIV_DE"
          RST 10H          ; DIV D with E
          LD A,D
          LD (MHEX),A      ; result MSB (HEX)

          LD D,0AH
          LD A,26H         ; call "MLT_DE"
          RST 10H
          EX DE,HL
          LD A,32H         ; call "CLE16"
          RST 10H
          LD H,00H
          LD L,32H
          LD A,32H         ; call "CLE16"
          RST 10H
          LD A,39H         ; call "CLDV:
          RST 10H
          LD A,36H         ; call "CLX16"
          RST 10H
          LD A,L
          LD (LHEX),A      ; save result LSB (HEX)

          LD A,(MHEX)      ; result MSB (HEX)
          LD (CBUF+0),A    ; store input HTOD
          LD A,20H
          RST 10H
          LD A,(CBUF+2)    ; result MSB (DEC)
          LD C,A
          LD A,1DH         ; HTOA
          RST 10H          ; HEX -> ASCII
          LD (MASC),DE     ; result MSB (ASCII)

          LD A,(LHEX)      ; result LSB (HEX)
          LD (CBUF+0),A
          LD A,20H
          RST 10H
          LD A,(CBUF+2)    ; result LSB (DEC)
          LD C,A
          LD A,1DH         ; HTOA
          RST 10H          ; HEX -> ASCII
          LD (LASC),DE    ; result LSB (ASCII)
          JR START


          ;*********************
          ;*  SET LCD DISPLAY  *
          ;*********************

DSPLCD:   LD HL,WORD       ; get word
          LD A,04H         ; display word
          RST 10H
          LD A,19H         ; call "CUR_OFF"
          RST 10H          ; cursor off
          LD A,(MASC)      ; MSB (ASCII)
          LD D,A
          LD A,0EH         ; display MSB
          RST 10H
          LD D,2EH         ; dot (ASCII)
          LD A,0EH         ; display "."
          RST 10H
          LD A,(LASC)      ; LSB (ASCII)
          LD D,A
          LD A,0EH         ; display LSB
          RST 10H
          LD D,56H         ; V (ASCII)
          LD A,0EH         ; display "V"
          RST 10H
          LD A,2EH         ; call "DMSEC"
          LD B,64H         ; delay time
          RST 10H
          RET

WORD:     DFB "DC INPUT : ",00H

MHEX:     DFS 2           ; MSB (HEX) buffer
LHEX:     DFS 2           ; LSB (HEX) buffer
MASC:     DFS 2           ; MSB (ASCII) buffer
LASC:     DFS 2           ; LSB (ASCII) buffer

          END
